# Created by pyp2rpm-3.3.5
%if 0%{?rhel}
%bcond_with docs
%else
%bcond_without docs
%endif
%bcond_without tests

%global pypi_name drgn

%global _description %{expand:
drgn (pronounced "dragon") is a debugger with an emphasis on programmability.
drgn exposes the types and variables in a program for easy, expressive
scripting in Python.}

Name:           python-%{pypi_name}
Version:        0.0.26+49.g0251d8f
Release:        1.20240515000737758909.pr394.49.g0251d8f%{?dist}
Summary:        Programmable debugger

License:        LGPL-2.1-or-later
URL:            https://github.com/osandov/drgn
Source0:        drgn-0.0.26+49.g0251d8f.tar.gz

BuildRequires:  python3-devel
BuildRequires:  python3dist(setuptools)
%if %{with docs}
BuildRequires:  sed
BuildRequires:  python3dist(sphinx)
BuildRequires:  python3-docs
%endif
%if %{with tests}
BuildRequires:  python3dist(pytest)
%endif
BuildRequires:  gcc-c++
BuildRequires:  make
BuildRequires:  bzip2-devel
BuildRequires:  elfutils-devel
BuildRequires:  libkdumpfile-devel
BuildRequires:  zlib-devel
BuildRequires:  xz-devel
# These are needed when building from git snapshots
BuildRequires:  autoconf
BuildRequires:  automake
BuildRequires:  libtool

%description %{_description}

%package -n     %{pypi_name}
Summary:        %{summary}

%description -n %{pypi_name} %{_description}

%if %{with docs}
%package -n %{pypi_name}-doc
Summary:        %{pypi_name} documentation
BuildArch:      noarch
Requires:       python3-docs

%description -n %{pypi_name}-doc %{_description}

This package contains additional documentation for %{pypi_name}.
%endif

%prep
%autosetup -n drgn-0.0.26+49.g0251d8f -p1
# Remove bundled egg-info
rm -rf %{pypi_name}.egg-info
%if %{with docs}
# Use local intersphinx inventory
sed -r \
    -e 's|https://docs.python.org/3|%{_docdir}/python3-docs/html|' \
    -i docs/conf.py
%endif
# Ensure version is always set, even when building from git snapshots
if [ ! -f drgn/internal/version.py ]; then
  echo '__version__ = "%{version}"' > drgn/internal/version.py
fi

%build
# verbose build
V=1 %py3_build

%if %{with docs}
# generate html docs
PYTHONPATH=${PWD} sphinx-build-3 docs html
# remove the sphinx-build leftovers
rm -rf html/.{doctrees,buildinfo}
%endif

%install
%py3_install
mkdir -p %{buildroot}%{_datadir}/drgn
cp -PR contrib tools %{buildroot}%{_datadir}/drgn

%if %{with tests}
%check
%pytest
%endif

%files -n %{pypi_name}
%license COPYING
%license LICENSES
%doc README.rst
%{_bindir}/drgn
%{_datadir}/drgn
%{python3_sitearch}/_%{pypi_name}.pyi
%{python3_sitearch}/_%{pypi_name}.cpython*.so
%{python3_sitearch}/%{pypi_name}
%{python3_sitearch}/%{pypi_name}-%{version}-py%{python3_version}.egg-info

%if %{with docs}
%files -n %{pypi_name}-doc
%license COPYING
%license LICENSES
%doc html
%endif

%changelog
* Wed May 15 2024 Packit <hello@packit.dev> - 0.0.26+49.g0251d8f-1.20240515000737758909.pr394.49.g0251d8f
- contrib: add negdentdelete.py script (Stephen Brennan)
- contrib/gcore.py: fix vma offset handling (Omar Sandoval)
- contrib: add script to extract process core dump from kernel (Omar Sandoval)
- libdrgn: examples: load_debug_info: fix build due to headers not being found (Omar Sandoval)
- libdrgn: stack_trace: get DW_AT_frame_base from containing DW_TAG_subprogram DIE (Omar Sandoval)
- vmtest.vm: don't try updating /etc/mtab from umount (Omar Sandoval)
- libdrgn: python: set Python error indicator if Program_hold_reserve() fails (Omar Sandoval)
- Translate path_iterator tests to C unit tests (Omar Sandoval)
- Translate C lexer tests to C unit tests (Omar Sandoval)
- Translate tests/test_lexer.py to C unit test (Omar Sandoval)
- Add scaffolding for libdrgn C unit tests (Omar Sandoval)
- libdrgn: pp: add PP_MAP() to call a macro on each variable argument (Omar Sandoval)
- libdrgn: pp: make PP_NARGS() expand to 0 (Omar Sandoval)
- Add Symbol constructor type annotation and documentation (Omar Sandoval)
- libdrgn: hash_table: fix compilation error on old GCC (Omar Sandoval)
- setup.py: flush stdout and stderr before GitHub Actions grouping commands (Omar Sandoval)
- helpers.linux.stackdepot: update stack_depot_fetch() for Linux 6.9 and 6.8.5, take 2 (Omar Sandoval)
- Revert "helpers.linux.stackdepot: update stack_depot_fetch() for Linux 6.9 and 6.8.2" (Omar Sandoval)
- libdrgn: hash_table: port table size reduction (Omar Sandoval)
- libdrgn: hash_table: prefetch the right thing when rehashing (Omar Sandoval)
- libdrgn: hash_table: limit maximum size correctly (Omar Sandoval)
- libdrgn: hash_table: replace zero-length array hack with typedef_if (Omar Sandoval)
- libdrgn: vector: fix vector_max_size (Omar Sandoval)
- tests: fix -Wmissing-prototypes warning in drgn_test kmod (Omar Sandoval)
- tests: test member_at_offset() on padding in nested structs/array elements (Omar Sandoval)
- helpers.common.type: add member_at_offset() helper (Omar Sandoval)
- libdrgn: make include paths stricter (Omar Sandoval)
- libdrgn/python: fix #includes in symbol.c (Omar Sandoval)
- contrib/search_kernel_memory.py: translate vmap addresses (Omar Sandoval)
- helpers.common.memory: recognize vmap stacks in identify_address() (Omar Sandoval)
- helper.common.memory: recognize vmap addresses in identify_address() (Omar Sandoval)
- helpers.linux.mm: add find_vmap_area() and for_each_vmap_area() (Omar Sandoval)
- helpers.common.memory: add print_annotated_memory() helper (Omar Sandoval)
- Add 6.9 to supported kernels (Omar Sandoval)
- helpers.linux.stackdepot: update stack_depot_fetch() for Linux 6.9 and 6.8.2 (Omar Sandoval)
- Add "Getting Help" section to README and docs main page (Omar Sandoval)
- Revert "vmtest.manage: work around broken 5.10 stable build" (Omar Sandoval)
- contrib: add script to search kernel memory (Omar Sandoval)
- tests: add infrastructure for test resources (Omar Sandoval)
- contrib/irq: fix for v6.5 and later kernels. (Imran Khan)
- libdrgn: ppc64: use DRGN_ERROR_NOT_IMPLEMENTED when virtual address translation is not supported (Omar Sandoval)
- Add test for Symbol Finder API (Stephen Brennan)
- python: Add Program.add_symbol_finder() (Stephen Brennan)
- python: Allow construction of Symbol objects (Stephen Brennan)
- libdrgn: move elf_symbols_search to debug_info.c (Stephen Brennan)
- libdrgn: Use Symbol Finder API in find_symbol_by_address_internal() (Stephen Brennan)
- libdrgn: move find_symbol_by_address_internal (Stephen Brennan)
- libdrgn: introduce Symbol Finder API (Stephen Brennan)
- libdrgn: shrink symbol binding & kind enums (Stephen Brennan)
